package inf1010.pusle.pathfinding;

import java.util.Queue;
import inf1010.pusle.pathfinding.graph.Vertex;

/**
 * A path finder interface for making path finding algorithms.
 */
public interface PathFinder {

    /**
     * Finds a path from start to target if it exists.
     *
     * @param start The vertex to start at.
     * @param target The target vertex.
     * @return A queue of vertices starting with start and ending with target.
     */
    public static Queue<Vertex> findPath(Vertex start, Vertex target);
}