package inf1010.pusle.pathfinding;

import java.util.Map;
import java.util.HashMap;
import java.util.Queue;
import inf1010.pusle.pathfinding.graph.*;

public class PathFinding {

    private Map<String, Vertex> graph = new HashMap<String, Vertex>();

    public static void main(String[] args) {
        PathFinding pf = new PathFinding();
        pf.graph.put("Ada", new Vertex("Ada", 9, 40));
        pf.graph.put("Bliss", new Vertex("Bliss", 9, 25));
        pf.graph.put("Caml", new Vertex("Caml", 22, 30));
        pf.graph.put("Delphi", new Vertex("Delphi", 20, 20));
        pf.graph.put("Euler", new Vertex("Euler", 10, 10));
        Vertex tmp = pf.graph.get("Ada");
        new Edge(tmp, pf.graph.get("Bliss"), 100);
        new Edge(tmp, pf.graph.get("Caml"), 40);
        new Edge(tmp, pf.graph.get("Euler"), 9000);
        tmp = pf.graph.get("Bliss");
        new Edge(tmp, pf.graph.get("Caml"), 70);
        new Edge(tmp, pf.graph.get("Delphi"), 5);
        new Edge(tmp, pf.graph.get("Euler"), 10);
        tmp = pf.graph.get("Delphi");
        new Edge(tmp, pf.graph.get("Caml"), 10);
        new Edge(tmp, pf.graph.get("Euler"), 20);
    }

    public void printPath(Queue<Vertex> path) {
        double distance = 0;
        Vertex last = null;
        for (Vertex v : path) {
            if (last != null)
                distance += last.getDistance(v);
            System.out.printf("%s \u2192 ", v.getName());
        }

        System.out.printf("%nTotal distance: %f%n", distance);
    }
}